/********************************************************************
	created:	2014/12/22	
	author:		M.Yang
	purpose:	UCI(united communicate interface)
*********************************************************************/

#ifndef uci_h__
#define uci_h__

#include "ucidef.h"

//////////////////////////////////////////////////////////////////////////
// ڽӿڷص״ֵ̬
//    < 0 : ʾ 
//    ӦĴϢͨuci_GetLastErrorȡ,Ķucidef.hļС
//     < UCI_ERRĴΪlibusbĴ롣
//////////////////////////////////////////////////////////////////////////

#ifdef __cplusplus
namespace uci {
extern "C"{
#endif
	//@brief : ִỰ޹صĲѯ
	//@param PRParams _params  : ѯĲ
	//@param u_byte * _data    : ݵĻַ
	//@param u_size _dataCount : ݵĻСBytes
	//@return u_status :  鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : 
	u_status _UCIAPI uci_Query(_in_out PRParams _params, _in_out u_byte* _data, _in u_size _dataCount);

	//@brief : ѯͨŽڵ
	//@param _in const QParams * _params : ѯ 
	//@param _out Node * _outBuf         : ŲѯĽڵ
	//@param _in_out u_size * _nodeCnt   : ΪҪȡĽڵΪʵʶȡĽڵ
	//@param _in u_size _timeOut         : ѯʱ
	//@return u_status  : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks :	
	u_status _UCIAPI uci_QueryNodes(_in const QParams* _params, _out Node* _outBuf, 
									_in_out u_size* _nodeCnt, _in u_size _timeOut);

	//@brief : ѯͨŽڵ
	//@param _msg        :  ѯַʽ磺  "LAN:4162,5000;USB:0x1234&0x5345,0x7777&0x5345;"
	//@param _nodes      :  ŲѯĽڵ
	//@param _node_count :  ҪѯĽڵ
	//@param _timeout    : ѯʱ
	//@return  : < 0 룻 >=0 ѯĽڵ㣨豸
	//@remarks : 
	u_status _UCIAPI uci_QueryNodesX(u_cstring _msg, Node* _nodes, u_size _node_count, _in u_size _timeout);

	/*21-7-2017 15:51 by M.J Created <򻯰汾ѯͨѶڵ㲢ͨŵַ>*/
	//@brief : ѯͨŽڵ
	//@param _addr_msg        :	ѯַʽ磺  "LAN:4162,5000;USB:0x1234&0x5345,0x7777&0x5345;"
	//@param _addr_msg_len	  :	յַַbufferĳ
	//@param _node_type		  :	ڵ
	//@param _timeout		  :	ѯʱ
	//@return  : < 0 룻 >=0 ѯĽڵ㣨豸
	//@remarks : 
	u_status _UCIAPI uci_QueryNodesX_Simple(u_tchar* _addr_msg, u_size _addr_msg_len, u_size _node_type, _in u_size _timeout);

	//@brief : 豸
	//@param u_cstring _addr      : 豸ַ '\0'β
	//@param u_session * _session : ѽĻỰID.
	//@param u_uint32 _timeOut    : ӳʱʱ ms
	//@return u_status : 鿴ļеġڽӿڷص״ֵ̬˵
	// UCI_SUCCESS
	// UCI_ERR_ARGS_WRONG; 
	// UCI_ERR_RES_INIT_ERROR; 
	// UCI_ERR_CONNECT_ADDR_WRONG;
	// UCI_ERR_CONNECT_FAILED;
	// UCI_ERR_CONNECT_TIMEOUT]
	//@remarks : ĵ
	u_status _UCIAPI uci_Open(u_cstring _addr, u_session* _session, u_uint32 _timeOut);

	//@brief          : 豸
	//@param _addr    : 豸ַ '\0'β
	//@param _timeOut : ӳʱʱ ms
	//@return :  < 0 룻 >=0 ỰID
	//@remarks : ӿuci_Openļ򻯰汾
	u_status _UCIAPI uci_OpenX(u_cstring _addr, u_uint32 _timeOut);

	//@brief : ִ
	//@param u_session _session : ỰID
	//@param PCommandParams _params : 
	//@return u_status : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : 
	u_status _UCIAPI uci_SendCommand(u_session _session, PCommandParams _params);

	//@brief : UCI¼
	//@param uciNotify _pNotify : ӦUCI¼Ļص
	//@return u_status _UCIAPI  :  鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : 
	u_status _UCIAPI uci_SetNotify(UCIMSGProc _pNotify);
	
	//@brief          : 
	//@param _msg     : ַ
	//@param _obj     : ݻַ
	//@param _objSize : ݻС
	//@return         : 鿴ļеġڽӿڷص״ֵ̬˵s
	//@remarks        : Ŀǰֻ֧л԰汾Ͷ豸ͷĵ¼鿴ĵ
	u_status _UCIAPI uci_SetAttribute(u_session _sesn, u_cstring _msg, const u_object* _obj, u_size _objSize);
	
	//@brief                   : ѯ
	//@param u_session _sesn   : 
	//@param u_attr _name      : 
	//@param u_attr_v * _value : 
	//@return u_status _UCIAPI : 
	//@remarks : 	
	u_status _UCIAPI uci_GetAttribute(u_session _sesn, u_cstring _msg, u_object* _obj, u_size _objSize);

	//@brief : д
	//@param u_session _session   : ỰID
	//@param PWParam _params      : д
	//@param const u_byte * _data : Ҫдݻַ ΪNULL
	//@param u_size _len          : Ҫдݻĳȣ _buf == NULL,_lenᱻԿΪκֵ
	//@return u_status : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks :  _dataΪnullʾ_params.CMDStringѾҪдֶˣʹuci_FormatWriteӿڣ
	//            _data != NULLַ_params.CMDStringֻܰһ䡣
	u_status _UCIAPI uci_Write(u_session _session, PWParams _params, const u_byte* _data, u_size _len);

	//@brief          :  д
	//@param _session :  ỰID
	//@param _msg     :  ַ'\0'β. ʽĵ
	//@param _timeout :  дʱ(λms)
	//@param _data    :  Ҫдݻַ ΪNULL
	//@param _len     :  Ҫдݻĳȣ _buf == NULL,_lenᱻԿΪκֵ
	//@return         :  鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks        :  _dataΪnullʾ_msgѾҪдֶˣ
	//                   _data != NULLַ_msgֻܰһ䡣
	u_status _UCIAPI uci_WriteX(u_session _session, u_cstring _msg, 
		u_uint32 _timeout, const u_byte* _data, u_size _len);

	//@brief          : ֻдַָдָӿ
	//@param _session : ỰID
	//@param _msg     : ַ'\0'β. ʽĵ
	//@param _timeout : дʱ(λms)
	//@return         : 鿴ļеġڽӿڷص״ֵ̬˵	
	//@remarks        : 
	u_status _UCIAPI uci_WriteSimple(u_session _session, u_cstring _msg, u_uint32 _timeout);

	//@brief : ʽд
	//@param u_session _sesn        : ỰID
	//@param u_uint32 _timeOut      : дʱ(λms)
	//@param const u_tchar * format : ַ'\0'β. ʽĵ
	//@param ... : 
	//@return u_status              : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : 
	u_status _UCIAPI uci_FormatWrite(u_session _sesn, u_uint32 _timeOut, const u_tchar *format, ...);

	//@brief : ȡ
	//@param u_session _session : ỰID
	//@param PRParams _params   : 
	//@param u_byte * _data     : ݵĻ
	//@param u_size _dataLen    : ݵĻССЭ
	//@return u_status :    鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : ʹuci_ReadX汾
	u_status _UCIAPI uci_Read(u_session _session, PRParams _params, u_byte* _data, u_size _dataLen);

	//@brief          : ȡ
	//@param _session : ỰID
	//@param _msg     : ַ'\0'β. ʽĵ
	//@param _timeout : ȡʱ
	//@param _data    : նȡݵĻַ
	//@param _dataLen : _dataָĻȣBytes
	//@return : 	鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : ӿuci_Readļ򻯰汾
	u_status _UCIAPI uci_ReadX(u_session _session, u_cstring _msg, 
		u_uint32 _timeout, u_byte* _data, u_size _dataLen);

	//@brief : дļ
	//@param u_session _session  : ỰID
	//@param WFileParams * _info : ļϢ
	//@return u_status : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : 
	u_status _UCIAPI uci_WriteFromFile(u_session _session, WFileParams* _info);

	//@brief           : дļ
	//@param _session  : ỰID
	//@param _msg      : ַ'\0'β. ʽĵ
	//@param _filePath : Ҫдļ·ļ
	//@param _timeout  : дʱ(λms)
	//@return : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : ӿuci_WriteFromFileļ򻯰汾
	u_status _UCIAPI uci_WriteFromFileX(u_session _session, u_cstring _msg,
		u_cstring _filePath, u_uint32 _timeout);

	//@brief : Read data synchronously and store the transferred data in a file.
	//@param u_session _session  : ỰID
	//@param RFileParams _params :  Ҫݵļ·
	//@return u_status  : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : 
	u_status _UCIAPI uci_ReadToFile(u_session _session, RFileParams* _params);

	//@brief : ȡļ
	//@param _session   : ỰID.
	//@param _msg       : ַ'\0'β. ʽĵ
	//@param _filePath  : ݵش̵ļ·ļͺ׺
	//Ǿ·Ҳ··ͨ_filePathFinalȡ·
	//@param _timeout   : ʱ
	//@param _filePathFinal       : 嵽صļľ·
	//@param _filePathFinalLength : _filePathFinalĳȣַ
	//@return : 鿴ļеġڽӿڷص״ֵ̬˵
	//@remarks : ӿuci_ReadToFileķǷװ汾
	u_status _UCIAPI uci_ReadToFileX(u_session _session, u_cstring _msg,
		u_cstring _filePath, u_uint32 _timeout, 
		u_tchar *_filePathFinal, u_int32 _filePathFinalLength);

	//@brief : رջỰ
	//@param u_session _session : ҪرյĻỰID
	//@return u_status  : 鿴ļеġڽӿڷص״ֵ̬˵
	u_status _UCIAPI uci_Close(u_session _session);

	//@brief : һβӦĴ״̬Ϣ
	//@return u_cstring : Ϣ
	//@remarks : ͨuci_SetAttributeôϢ԰汾
	u_cstring _UCIAPI uci_GetLastError(void);

	//@brief   : ˳UCIʵʱá		
	//@remarks : ˳ʱãͷڲԴ  
	// ӿڲһҪʹá ֻ.NETйܻ£
	// ͨuci_SetAttribute uci_SetNotifyӿ
	// 豸Ƴ¼ʱ˳ʱʹá
	void _UCIAPI uci_ExInstance(void);
#ifdef __cplusplus
}

}
#endif
#endif // uci_h__
